<script setup lang="ts">
	import { onMounted, ref } from 'vue';
	import { formatDate } from '../../utils/date';
	import { getAction, postAction } from '../../common/http';
	import { showToast } from 'vant';

	const showDialog = ref(false)
	const craftList = ref([] as any[])
	const colorList = ref([])
	onMounted(() => {
		uni.getStorage({
			key: 'info',
			success(res) {
				let data = JSON.parse(res.data)
				form.value.makeUser = data.userName
			},
			fail: (err : any) => {
				console.log(err);
			}
		})
		getAction('/fabric/craft/info').then((res : any) => {
			if (res.code === 200) {
				craftList.value = res.data.map((l : any) => ({ value: l.name, text: l.name }))
			}
		})
		getAction('/fabric/info/all').then((res : any) => {
			if (res.code === 200) {
				res.data.forEach((l : any) => {
					let itemMl = mlList.value.find(m => m.text === l.commodity)
					if (itemMl) {
						let itemMm = itemMl.children.find(m => m.value === l.momme)
						if (itemMm) {
							itemMm.children.push({ text: l.width + 'cm', value: l.width })
						} else {
							itemMl.children.push({
								text: l.momme + 'mm',
								value: l.momme,
								children: [{ text: l.width + 'cm', value: l.width }]
							})
						}
					} else {
						mlList.value.push({
							text: l.commodity,
							value: l.commodity,
							children: [{ text: l.momme + 'mm', value: l.momme, children: [{ text: l.width + 'cm', value: l.width }] }]
						})
					}
				})
			}
		})
		getAction('/color/list').then((res : any) => {
			if (res.code === 200) {
				colorList.value = res.data.map((l : any) => ({ value: l.colorCode + l.colorName, text: l.colorCode + l.colorName }))
			}
		})
	})

	const onClickLeft = () => {
		history.back()
	}

	const addfabric = () => {
		showDialog.value = true
		fabric.value = JSON.parse(JSON.stringify(form.value.fabric))
	}

	//弹窗提交
	const confirmSecond = () => {
		showDialog.value = false
		form.value.fabric = JSON.parse(JSON.stringify(fabric.value))
	}
	const onSubmit = () => {
		let set=new Set()
		let tj=true
		form.value.fabric.forEach((l:any)=>{
			if(!l.name){
				tj=false
			}else{
				let width=l.name.split('/')[0]
				set.add(width)
			}
			
			if(!l.quantity||!l.belongTo){
				tj=false
			}
		})
		if(!tj) return showToast('请填写完整信息！')
		if([...set].length>1) return showToast('相同门幅才可以提交!')
		postAction('/interOrder',form.value).then((res:any)=>{
			if(res.code===200){
				showToast('提交成功！')
				window.history.back()
			}
		})
	}

	const form = ref({ makeTime: formatDate(new Date()), fabric: [{ belongTo: '门店' }], craft: '染色' } as any)
	const fabric = ref([{ belongTo: '门店' }] as any[])
	const showPicker = ref(false)
	const typeData = ref()
	const popuList = ref([] as any[])
	const show = ref(false)
	const pickerList = ref([])//面料数据
	const pickerContainerList = ref([])
	const showPickerList = ref(false)
	const searchValue = ref('')//查询的值
	const searchIndex = ref(0)//查询到的数组
	const mlList = ref([])
	//选择框事件
	const choosePic = (type : any) => {
		showPicker.value = true
		typeData.value = type
	}
	//选择框确认
	const pickerConfirm = (val : any) => {
		form.value[typeData.value] = val.selectedValues[0]
		showPickerCancel()
	}
	//取消
	const showPickerCancel = () => {
		showPicker.value = false
	}
	//弹窗开启事件
	const handleOpen = () => {
		if (typeData.value === 'craft') {
			popuList.value = craftList.value
		} else if (typeData.value === 'color') {
			popuList.value = colorList.value
		}
	}
	const chooseDate = () => {
		show.value = true
	}
	//日期选择
	const onConfirmDate = (val : any) => {
		form.value.createTime = formatDate(val)
		show.value = false
	}

	//选择面料
	const selectChoose = (index : any) => {
		showPickerList.value = true
		typeData.value = index
	}
	//面料开启
	const mlmcOpen = () => {
		pickerList.value = mlList.value
		pickerContainerList.value = pickerList.value
		searchValue.value = ''
	}
	//面料关闭
	const pickerCancel = () => {
		showPickerList.value = false
	}

	//搜索
	const selectedValue = ref()
	const getSeachList = () => {
		searchIndex.value = 0
		let reg = new RegExp(searchValue.value)
		let arr = []
		pickerList.value.forEach(l => {
			if (reg.test(l.text)) {
				arr.push(l)
			}
		})
		pickerContainerList.value = arr
	}
	//向上选择
	const upSearch = () => {
		if (searchIndex.value === 0 && pickerContainerList.value.length) {
			searchIndex.value = pickerContainerList.value.length - 1
			selectedValue.value = [pickerContainerList.value[searchIndex.value].text]
		} else if (pickerContainerList.value.length) {
			searchIndex.value--
			selectedValue.value = [pickerContainerList.value[searchIndex.value].text]
		} else {
			showToast('没有了！')
		}
	}
	//向下选择
	const downSearch = () => {
		if (pickerContainerList.value.length) {
			if (searchIndex.value === pickerContainerList.value.length) {
				searchIndex.value = 0
				selectedValue.value = [pickerContainerList.value[searchIndex.value].text]
			} else {
				searchIndex.value++
				selectedValue.value = [pickerContainerList.value[searchIndex.value].text]
			}
		} else {
			showToast('没有了！')
		}
	}
	//搜索框输入
	const timer = ref()
	const searchTo = () => {
		if (timer.value) {
			clearTimeout(timer.value)
		}
		timer.value = setTimeout(() => {
			getSeachList()
		}, 800)
	}
	const onConfirm = (val : any) => {
		fabric.value[typeData.value].name = val.selectedValues[2] + '/' + val.selectedValues[0] + val.selectedValues[1]
		pickerCancel()
	}
</script>

<template>
	<view class="flex">
		<van-nav-bar title="现货需求单" left-text="返回" left-arrow @click-left="onClickLeft" />
		<view class="content">
			<van-form @submit="onSubmit">
				<van-cell-group inset>
					<van-field v-model="form.makeTime" name="做单日期" label="做单日期" colon class="bor" label-width="5em"
						readonly :rules="[{ required: true, message: '请填写' }]" @click="chooseDate()" />
					<van-field v-model="form.makeUser" name="做单人" label="做单人" colon label-width="5em"
						:rules="[{ required: true, message: '请填写' }]" />
					<van-field v-model="form.color" name="颜色色号" label="颜色色号" colon class="bor" readonly
						:rules="[{ required: true, message: '请填写' }]" label-width="5em" @click="choosePic('color')" />
					<van-field v-model="form.craft" name="工艺" label="工艺" colon
						:rules="[{ required: true, message: '请填写' }]" label-width="5em" readonly class="bor"
						@click="choosePic('craft')" />
					<view class="a-b">
						<van-button type="primary" @click="addfabric">面料添加</van-button>
					</view>
					<view class="grid-container">
						<view class="grid-item">面料名称</view>
						<view class="grid-item">匹数</view>
						<view class="grid-item">库存</view>
						<view class="grid-item">谁定</view>
						<view class="grid-item">操作</view>
					</view>
					<view class="grid-container" v-for="(item,index) in form.fabric" :key="index">
						<view class="grid-item">{{item.name}}</view>
						<view class="grid-item">{{item.quantity}}</view>
						<view class="grid-item">{{item.storageQuantity}}</view>
						<view class="grid-item">{{item.belongTo}}</view>
						<view class="grid-item" style="color: red;" @click="form.fabric.splice(index,1)">删除</view>
					</view>
					<van-field v-model="form.comment" name="备注" label="备注" colon label-width="5em" />
				</van-cell-group>
				<view style="margin: 16px;">
					<van-button round block type="primary" native-type="submit">
						提交
					</van-button>
				</view>
			</van-form>
		</view>
	</view>

	<van-dialog v-model:show="showDialog">
		<view>
			<van-cell-group inset>
				<view v-for="(item,index) in fabric" :key="index">
					<view class="a-c">
						<van-icon name="add" color="red" size="25" v-if="index===0"
							@click="fabric.push({belongTo:'门店'})" />
						<van-icon name="clear" color="red" size="25" v-if="index!=0" @click="fabric.splice(index,1)" />
						<van-field v-model="item.name" name="面料名称" label="面料名称" colon readonly label-width="5em"
							@click="selectChoose(index)" class="bor" />
					</view>
					<van-field v-model="item.quantity" name="需求匹数" label="需求匹数" type="number" colon
						label-width="6.5em" />
					<!-- <van-field v-model="item.storageQuantity" name="库存匹数" label="库存匹数" colon label-width="6.5em"
						readonly /> -->
					<van-field v-model="item.belongTo" name="订单归属人" label="订单归属人" colon label-width="6.5em" readonly/>
				</view>
			</van-cell-group>
		</view>
		<template #footer>
			<view class="footer-button">
				<van-button plain size="small" native-type="button" style="width: 25vw;" @click="showDialog=false">
					取消
				</van-button>
				<van-button size="small" type="success" native-type="submit" style="width: 25vw;"
					@click="confirmSecond">
					确认
				</van-button>
			</view>
		</template>
	</van-dialog>


	<van-calendar v-model:show="show" @confirm="onConfirmDate" :min-date="new Date(2010, 0, 1)"
		:max-date="new Date(2050, 0, 31)" />

	<!--选择框-->
	<van-popup v-model:show="showPicker" round position="bottom" @open="handleOpen">
		<van-picker show-toolbar :columns="popuList" @confirm="pickerConfirm" @cancel="showPickerCancel"
			ref="pickerRef" />
	</van-popup>

	<!--    面料选择框-->
	<van-popup v-model:show="showPickerList" position="bottom" @open="mlmcOpen">
		<view class="select-model">
			<van-picker :columns="pickerContainerList" @cancel="pickerCancel" v-model="selectedValue"
				@confirm="onConfirm" />
			<view>
				<view class="top-select">
					<view class="confirm-select">
						<p>请选择品种</p>
					</view>
					<view class="search-box">
						<view>
							<van-search placeholder="请输入品种名字" v-model="searchValue" label="面料搜索：" background="#ffffff"
								@input="searchTo()" :clearable="false" />
						</view>
						<view class="flex-btn">
							<button class="search-btn" @click="upSearch()">↑</button>
							<button class="search-btn" @click="downSearch()">↓</button>
						</view>
					</view>
				</view>
			</view>
		</view>
	</van-popup>
</template>

<style lang="scss" scoped>
	.flex {
		display: flex;
		flex-direction: column;
		height: 100vh;
		width: 100vw;

		.van-nav-bar {
			width: 100%;
		}

		.content {
			flex: 1;
			padding: 0 10px;

			.grid-container {
				display: grid;
				grid-template-columns: 2fr 1fr 1.5fr 1fr 1fr;

				.grid-item {
					border: 1px solid #f2f2f2;
					text-align: center;
					padding: 15rpx 0;

					::v-deep .van-cell {
						padding: 0 5px;
					}
				}
			}
		}
	}

	.footer-button {
		margin: 20px;
		display: flex;
		justify-content: space-around;
	}

	::v-deep .van-field {
		font-size: 16px;
	}

	.a-b {
		margin: 10rpx;

		::v-deep .van-button--normal {
			padding: 5px 8px;
			height: 30px;
		}
	}

	.a-c {
		display: flex;
		align-items: center;

		::v-deep .van-button--normal {
			padding: 8rpx;
			height: 50rpx;
			width: 7em;
		}
	}

	.bor {
		::v-deep .van-field__control {
			border: 1px solid #d7d7d7;
		}
	}

	::v-deep .van-field__control {
		border-bottom: 1px solid #d7d7d7;
		text-align: center;
		font-size: 16px;
	}

	::v-deep .van-field__label {
		text-align: end;
	}

	/*面料选择搜索框*/
	.select-model {
		position: relative;
	}

	.confirm-select {
		width: 100%;
	}

	.confirm-select>p {
		text-align: center;
	}

	.confirm-select>button {
		border: none;
		background-color: #ffffff;
		color: #388aed;
		margin: 10px 30px 0 0;
	}

	.top-select {
		position: absolute;
		top: 30px;
		left: 0;
		right: 0;
		margin: auto;
		z-index: 999;
	}

	::v-deep .select-model .van-picker__toolbar {
		height: 66px;
		align-items: flex-start;
		/*justify-content: flex-end;*/
	}

	::v-deep .select-model .van-picker__cancel,
	.select-model .van-picker__confirm {
		height: 30px;
		padding: 10px 16px 0;
	}

	.search-btn {
		padding: 1px 8px;
		border: none;
		background-color: #388aed;
		color: #ffffff;
		margin-left: 5px;
		height: 30px;
		line-height: 25px;
	}

	.search-box {
		display: flex;
		flex-direction: row;
		align-items: center;
		justify-content: center;
		padding-top: 15px;
		padding-bottom: 5px;
		position: relative;
		background-color: #fff;
	}

	.van-search {
		background-color: #f7f7f8;
	}

	.ml-search-jump {
		padding: 3px 10px;
		background-color: #388aed;
		color: #ffffff;
		border: none;
		margin-left: 10px;
	}

	.flex-btn {
		display: flex;
		flex-direction: row;
		align-items: center;
		justify-content: space-between;
	}
</style>